freedombone-app-pleroma 52KB

1234567891011121314151617181920212223242526272829303132333435363738394041424344454647484950515253545556575859606162636465666768697071727374757677787980818283848586878889909192939495969798991001011021031041051061071081091101111121131141151161171181191201211221231241251261271281291301311321331341351361371381391401411421431441451461471481491501511521531541551561571581591601611621631641651661671681691701711721731741751761771781791801811821831841851861871881891901911921931941951961971981992002012022032042052062072082092102112122132142152162172182192202212222232242252262272282292302312322332342352362372382392402412422432442452462472482492502512522532542552562572582592602612622632642652662672682692702712722732742752762772782792802812822832842852862872882892902912922932942952962972982993003013023033043053063073083093103113123133143153163173183193203213223233243253263273283293303313323333343353363373383393403413423433443453463473483493503513523533543553563573583593603613623633643653663673683693703713723733743753763773783793803813823833843853863873883893903913923933943953963973983994004014024034044054064074084094104114124134144154164174184194204214224234244254264274284294304314324334344354364374384394404414424434444454464474484494504514524534544554564574584594604614624634644654664674684694704714724734744754764774784794804814824834844854864874884894904914924934944954964974984995005015025035045055065075085095105115125135145155165175185195205215225235245255265275285295305315325335345355365375385395405415425435445455465475485495505515525535545555565575585595605615625635645655665675685695705715725735745755765775785795805815825835845855865875885895905915925935945955965975985996006016026036046056066076086096106116126136146156166176186196206216226236246256266276286296306316326336346356366376386396406416426436446456466476486496506516526536546556566576586596606616626636646656666676686696706716726736746756766776786796806816826836846856866876886896906916926936946956966976986997007017027037047057067077087097107117127137147157167177187197207217227237247257267277287297307317327337347357367377387397407417427437447457467477487497507517527537547557567577587597607617627637647657667677687697707717727737747757767777787797807817827837847857867877887897907917927937947957967977987998008018028038048058068078088098108118128138148158168178188198208218228238248258268278288298308318328338348358368378388398408418428438448458468478488498508518528538548558568578588598608618628638648658668678688698708718728738748758768778788798808818828838848858868878888898908918928938948958968978988999009019029039049059069079089099109119129139149159169179189199209219229239249259269279289299309319329339349359369379389399409419429439449459469479489499509519529539549559569579589599609619629639649659669679689699709719729739749759769779789799809819829839849859869879889899909919929939949959969979989991000100110021003100410051006100710081009101010111012101310141015101610171018101910201021102210231024102510261027102810291030103110321033103410351036103710381039104010411042104310441045104610471048104910501051105210531054105510561057105810591060106110621063106410651066106710681069107010711072107310741075107610771078107910801081108210831084108510861087108810891090109110921093109410951096109710981099110011011102110311041105110611071108110911101111111211131114111511161117111811191120112111221123112411251126112711281129113011311132113311341135113611371138113911401141114211431144114511461147114811491150115111521153115411551156115711581159116011611162116311641165116611671168116911701171117211731174117511761177117811791180118111821183118411851186118711881189119011911192119311941195119611971198119912001201120212031204120512061207120812091210121112121213121412151216121712181219122012211222122312241225122612271228122912301231123212331234123512361237123812391240124112421243124412451246124712481249125012511252125312541255125612571258125912601261126212631264126512661267126812691270127112721273127412751276127712781279128012811282128312841285128612871288128912901291129212931294129512961297129812991300130113021303130413051306130713081309131013111312131313141315131613171318131913201321132213231324132513261327132813291330133113321333133413351336133713381339134013411342134313441345134613471348134913501351135213531354135513561357135813591360136113621363136413651366136713681369137013711372137313741375137613771378137913801381138213831384138513861387138813891390139113921393139413951396139713981399
  1. #!/bin/bash
  2. # _____ _ _
  3. # | __|___ ___ ___ _| |___ _____| |_ ___ ___ ___
  4. # | __| _| -_| -_| . | . | | . | . | | -_|
  5. # |__| |_| |___|___|___|___|_|_|_|___|___|_|_|___|
  6. #
  7. # Freedom in the Cloud
  8. #
  9. # Pleroma backend application
  10. #
  11. # License
  12. # =======
  13. #
  14. # Copyright (C) 2017-2018 Bob Mottram <bob@freedombone.net>
  15. #
  16. # This program is free software: you can redistribute it and/or modify
  17. # it under the terms of the GNU Affero General Public License as published by
  18. # the Free Software Foundation, either version 3 of the License, or
  19. # (at your option) any later version.
  20. #
  21. # This program is distributed in the hope that it will be useful,
  22. # but WITHOUT ANY WARRANTY; without even the implied warranty of
  23. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  24. # GNU Affero General Public License for more details.
  25. #
  26. # You should have received a copy of the GNU Affero General Public License
  27. # along with this program. If not, see <http://www.gnu.org/licenses/>.
  28. VARIANTS='full full-vim social'
  29. IN_DEFAULT_INSTALL=0
  30. SHOW_ON_ABOUT=1
  31. PLEROMA_DOMAIN_NAME=
  32. PLEROMA_CODE=
  33. PLEROMA_PORT=4000
  34. PLEROMA_ONION_PORT=8011
  35. PLEROMA_REPO="https://git.pleroma.social/pleroma/pleroma.git"
  36. PLEROMA_COMMIT='ad28854f477141dc9b6a01f7e4465c07bb0f896c'
  37. PLEROMA_ADMIN_PASSWORD=
  38. PLEROMA_DIR=/etc/pleroma
  39. PLEROMA_SECRET_KEY=""
  40. pleroma_secret=$PLEROMA_DIR/config/dev.secret.exs
  41. PLEROMA_BACKGROUND_IMAGE_URL=
  42. PLEROMA_TITLE='Pleroma Server'
  43. # Number of months after which posts expire
  44. PLEROMA_EXPIRE_MONTHS=3
  45. pleroma_expire_posts_script=/usr/bin/pleroma-expire-posts
  46. blocking_script_file=/usr/bin/pleroma-blocking
  47. PLEROMA_SHORT_DESCRIPTION=$'Federated microblogging'
  48. PLEROMA_DESCRIPTION=$'Federated microblogging'
  49. PLEROMA_MOBILE_APP_URL='https://f-droid.org/packages/com.keylesspalace.tusky'
  50. pleroma_variables=(ONION_ONLY
  51. PLEROMA_DOMAIN_NAME
  52. PLEROMA_CODE
  53. PLEROMA_WELCOME_MESSAGE
  54. PLEROMA_BACKGROUND_IMAGE_URL
  55. DDNS_PROVIDER
  56. PLEROMA_TITLE
  57. PLEROMA_EXPIRE_MONTHS
  58. MY_EMAIL_ADDRESS
  59. MY_USERNAME)
  60. function pleroma_add_filtering {
  61. if grep -q "# begin filtering" $pleroma_secret; then
  62. return
  63. fi
  64. sed -i '/pbkdf2_rounds/a reject: []' $pleroma_secret
  65. sed -i '/pbkdf2_rounds/a federated_timeline_removal: [],' $pleroma_secret
  66. sed -i '/pbkdf2_rounds/a media_nsfw: [],' $pleroma_secret
  67. sed -i '/pbkdf2_rounds/a media_removal: [],' $pleroma_secret
  68. sed -i '/pbkdf2_rounds/a config :pleroma, :mrf_simple,' $pleroma_secret
  69. sed -i '/pbkdf2_rounds/a # begin filtering' $pleroma_secret
  70. sed -i 's|reject: | reject: |g' $pleroma_secret
  71. sed -i 's|federated_timeline_removal: | federated_timeline_removal: |g' $pleroma_secret
  72. sed -i 's|media_nsfw: | media_nsfw: |g' $pleroma_secret
  73. sed -i 's|media_removal: | media_removal: |g' $pleroma_secret
  74. create_pleroma_blocklist
  75. }
  76. function pleroma_enable_chat {
  77. if [[ "$1" == 't'* || "$1" == 'y'* || "$1" == 'T'* || "$1" == 'Y'* ]]; then
  78. sed -i 's|"chatDisabled":.*|"chatDisabled": false,|g' $PLEROMA_DIR/priv/static/static/config.json
  79. sed -i 's|:chat, enabled:.*|:chat, enabled: true|g' $PLEROMA_DIR/config/config.exs
  80. else
  81. sed -i 's|"chatDisabled":.*|"chatDisabled": true,|g' $PLEROMA_DIR/priv/static/static/config.json
  82. sed -i 's|:chat, enabled:.*|:chat, enabled: false|g' $PLEROMA_DIR/config/config.exs
  83. fi
  84. pleroma_recompile
  85. }
  86. function create_pleroma_blocklist {
  87. { echo '#!/bin/bash';
  88. echo "if [ ! -f /root/${PROJECT_NAME}-firewall-domains.cfg ]; then";
  89. echo ' exit 0';
  90. echo 'fi';
  91. echo 'if [ -f /tmp/pleroma-blocking.lock ]; then';
  92. echo ' cd /tmp';
  93. echo ' find ./pleroma*.lock -type f -mmin +5 -exec rm {} \;';
  94. echo ' if [ -f /tmp/pleroma-blocking.lock ]; then';
  95. echo ' exit 0';
  96. echo ' fi';
  97. echo 'fi';
  98. echo 'touch /tmp/pleroma-blocking.lock';
  99. echo 'objects_query="DELETE FROM objects WHERE"';
  100. echo 'objects_updated=';
  101. echo 'users_query="DELETE FROM users WHERE"';
  102. echo 'websub_server_subscriptions_query="DELETE FROM websub_server_subscriptions WHERE"';
  103. echo 'websub_server_subscriptions_updated=';
  104. echo 'filter_str=';
  105. echo 'while read blocked; do';
  106. echo " if [[ \"\$blocked\" == *\".\"* || \"\$blocked\" == *\"@\"* ]]; then";
  107. echo " if [ \${#blocked} -gt 4 ]; then";
  108. echo " if [ \$objects_updated ]; then";
  109. echo " objects_query=\"\${objects_query} or\"";
  110. echo " users_query=\"\${users_query} or\"";
  111. echo ' fi';
  112. echo " objects_query=\"\${objects_query} data->>'content' ilike '%\${blocked}%' or data->>'actor' ilike '%\${blocked}%' or data->>'to' ilike '%\${blocked}%' or data->>'id' ilike '%\${blocked}%' or data->>'external_url' ilike '%\${blocked}%'\"";
  113. echo " users_query=\"\${users_query} nickname ilike '%\${blocked}%'\"";
  114. echo ' objects_updated=1';
  115. echo " if [[ \"\$blocked\" != *\"@\"* ]]; then";
  116. echo ' # Create a filter string for the pleroma configuration';
  117. echo " if [ \"\$filter_str\" ]; then";
  118. echo " filter_str=\"\${filter_str}, \\\"\$blocked\\\"\"";
  119. echo ' else';
  120. echo " filter_str=\"\\\"\${blocked}\\\"\"";
  121. echo ' fi';
  122. echo '';
  123. echo " if ! grep -q \"127.0.0.1 \$blocked\" /etc/hosts; then";
  124. echo " echo \"127.0.0.1 \$blocked\" >> /etc/hosts";
  125. echo ' fi';
  126. echo " if [ \$websub_server_subscriptions_updated ]; then";
  127. echo " websub_server_subscriptions_query=\"\${websub_server_subscriptions_query} or\"";
  128. echo ' fi';
  129. echo " websub_server_subscriptions_query=\"\${websub_server_subscriptions_query} callback like '%\${blocked}%'\"";
  130. echo ' websub_server_subscriptions_updated=1';
  131. echo ' else';
  132. echo " curr_user_query=\"SELECT nickname FROM users where nickname ilike '%\${blocked}%'\"";
  133. echo " curr_user_present=\$(sudo -u postgres psql -d pleroma -c \"\$curr_user_query\")";
  134. echo " if [[ \"\$curr_user_present\" != *'(0 '* ]]; then";
  135. echo " cd $PLEROMA_DIR";
  136. echo " sudo -u pleroma mix deactivate_user \${blocked}";
  137. echo ' fi';
  138. echo ' fi';
  139. echo ' fi';
  140. echo ' fi';
  141. echo 'done </root/freedombone-firewall-domains.cfg';
  142. echo '';
  143. echo "if [ \"\$filter_str\" ]; then";
  144. echo " if ! grep -q \" \$filter_str \" $pleroma_secret; then";
  145. echo " sed -i \"s| media_removal:.*| media_removal: [ \$filter_str ],|g\" $pleroma_secret";
  146. echo " sed -i \"s| federated_timeline_removal:.*| federated_timeline_removal: [ \$filter_str ],|g\" $pleroma_secret";
  147. echo " sed -i \"s| reject:.*| reject: [ \$filter_str ]|g\" $pleroma_secret";
  148. echo " chown -R pleroma:pleroma $PLEROMA_DIR";
  149. echo ' sudo -u pleroma mix clean';
  150. echo ' sudo -u pleroma mix deps.compile';
  151. echo ' sudo -u pleroma mix compile';
  152. echo ' systemctl restart pleroma';
  153. echo ' fi';
  154. echo 'fi';
  155. echo '';
  156. echo '#cd /etc/postgresql';
  157. echo "#if [ \$objects_updated ]; then";
  158. echo "# sudo -u postgres psql -d pleroma -c \"\$objects_query\"";
  159. echo "# sudo -u postgres psql -d pleroma -c \"\$users_query\"";
  160. echo '#fi';
  161. echo "#if [ \$websub_server_subscriptions_updated ]; then";
  162. echo "# sudo -u postgres psql -d pleroma -c \"\$websub_server_subscriptions_query\"";
  163. echo '#fi';
  164. echo 'rm /tmp/pleroma-blocking.lock'; } > $blocking_script_file
  165. chmod +x $blocking_script_file
  166. if ! grep -q "$blocking_script_file" /etc/crontab; then
  167. cron_add_mins 1 "$blocking_script_file 2> /dev/null"
  168. fi
  169. }
  170. function expire_pleroma_posts {
  171. domain_name=$1
  172. expire_months=$3
  173. if [ ! "$expire_months" ]; then
  174. expire_months=3
  175. fi
  176. #expire_days=$((expire_months * 30))
  177. # files are what take up most of the backup time, so don't keep them for very long
  178. expire_days_files=7
  179. # To prevent the database size from growing endlessly this script expires posts
  180. # after a number of months
  181. if [ ! -d /etc/pleroma ]; then
  182. return
  183. fi
  184. { echo '#!/bin/bash';
  185. echo "plmonths=\"$PLEROMA_EXPIRE_MONTHS\"";
  186. echo "if [ \${#plmonths} -eq 0 ]; then";
  187. echo ' exit 1';
  188. echo 'fi';
  189. echo "if [[ \"\$plmonths\" == \"0\" ]]; then";
  190. echo ' exit 2';
  191. echo 'fi';
  192. echo "oldate=\$(date +%Y-%m-%d --date=\"\$plmonths months ago\")";
  193. echo 'cd /etc/postgresql';
  194. echo "sudo -u postgres psql -d pleroma -c \"DELETE FROM notifications WHERE inserted_at <= '\$oldate 01:01:01'\"";
  195. echo "sudo -u postgres psql -d pleroma -c \"DELETE FROM objects WHERE inserted_at <= '\$oldate 01:01:01'\""; } > $pleroma_expire_posts_script
  196. chmod +x $pleroma_expire_posts_script
  197. pleroma_expire_script=/etc/cron.daily/pleroma-expire
  198. expire_days_files_threshold=$((expire_days_files - 1))
  199. { echo '#!/bin/bash';
  200. echo 'cd /etc/postgresql';
  201. echo 'if [ -d /etc/pleroma/tempfiles ]; then';
  202. echo ' rm -rf /etc/pleroma/tempfiles';
  203. echo 'fi';
  204. echo '';
  205. echo '# make directory to temporarily store local avatars';
  206. echo 'mkdir /etc/pleroma/tempfiles';
  207. echo '';
  208. echo '# get the local avatar files';
  209. echo "avatars=\$(sudo -u postgres psql -d pleroma -c \"select avatar->>'url' from users where avatar->>'url' like '%${domain_name}%'\")";
  210. echo '';
  211. echo '# copy the avatar files to a temporary directory';
  212. echo "arr=( \$avatars )";
  213. echo "for i in \${arr[@]}; do";
  214. echo " if [[ \"\$i\" == *'/media/'* ]]; then";
  215. echo " imagefile=/etc/pleroma/uploads/\$(echo \$i | sed 's|\"||g' | sed 's|,||g' | awk -F '/media/' '{print \$2}');";
  216. echo " if [ -f \$imagefile ]; then";
  217. echo " imagedir=/etc/pleroma/uploads/\$(echo \$i | sed 's|\"||g' | sed 's|,||g' | awk -F '/media/' '{print \$2}' | awk -F '/' '{print \$1}')";
  218. echo " nowdate=\$(date +%s)";
  219. echo " sinceepoch=\$(date +%s -r \$imagefile)";
  220. echo " daysold=\$(((\$nowdate - \$sinceepoch) / 86400))";
  221. echo " if [ \$daysold -ge ${expire_days_files_threshold} ]; then";
  222. echo " if [ ! -d \$imagedir ]; then";
  223. echo " mkdir \$imagedir";
  224. echo ' fi';
  225. echo " cp -rp \$imagefile \$imagedir";
  226. echo ' fi';
  227. echo ' fi';
  228. echo ' fi';
  229. echo 'done';
  230. echo '';
  231. echo '# get the local banner files';
  232. echo "banners=\$(sudo -u postgres psql -d pleroma -c \"select avatar->>'banner' from users where avatar->>'url' like '%${domain_name}%'\")";
  233. echo '';
  234. echo '# copy the banner files to a temporary directory';
  235. echo "arr=( \$banners )";
  236. echo "for i in \${arr[@]}; do";
  237. echo " if [[ \"\$i\" == *'/media/'* ]]; then";
  238. echo " imagefile=/etc/pleroma/uploads/\$(echo \$i | sed 's|\"||g' | sed 's|,||g' | awk -F '/media/' '{print \$2}');";
  239. echo " if [ -f \$imagefile ]; then";
  240. echo " imagedir=/etc/pleroma/uploads/\$(echo \$i | sed 's|\"||g' | sed 's|,||g' | awk -F '/media/' '{print \$2}' | awk -F '/' '{print \$1}')";
  241. echo " nowdate=\$(date +%s)";
  242. echo " sinceepoch=\$(date +%s -r \$imagefile)";
  243. echo " daysold=\$(((\$nowdate - \$sinceepoch) / 86400))";
  244. echo " if [ \$daysold -ge ${expire_days_files_threshold} ]; then";
  245. echo " if [ ! -d \$imagedir ]; then";
  246. echo " mkdir \$imagedir";
  247. echo ' fi';
  248. echo " cp -rp \$imagefile \$imagedir";
  249. echo ' fi';
  250. echo ' fi';
  251. echo ' fi';
  252. echo 'done';
  253. echo '';
  254. echo '# delete old files';
  255. echo "find /etc/pleroma/uploads/* -mtime +${expire_days_files} -exec rm -rf {} +";
  256. echo '';
  257. echo '# move avatar files back to uploads';
  258. echo 'chown -R pleroma:pleroma /etc/pleroma/tempfiles';
  259. echo 'mv /etc/pleroma/tempfiles/* /etc/pleroma/uploads';
  260. echo 'rm -rf /etc/pleroma/tempfiles';
  261. echo '';
  262. echo '/usr/bin/pleroma-expire-posts 2> /dev/null'; } > $pleroma_expire_script
  263. chmod +x $pleroma_expire_script
  264. # remove any old cron job
  265. if grep -q "pleroma-expire" /etc/crontab; then
  266. sed -i "/pleroma-expire/d" /etc/crontab
  267. rm /usr/bin/pleroma-expire
  268. fi
  269. # remove old expire script
  270. if [ -f /etc/cron.weekly/clear-pleroma-database ]; then
  271. rm /etc/cron.weekly/clear-pleroma-database
  272. fi
  273. }
  274. function pleroma_recompile {
  275. # necessary after parameter changes
  276. chown -R pleroma:pleroma $PLEROMA_DIR
  277. sudo -u pleroma mix clean
  278. sudo -u pleroma mix deps.compile
  279. sudo -u pleroma mix compile
  280. if [ -f /etc/systemd/system/pleroma.service ]; then
  281. systemctl restart pleroma
  282. fi
  283. }
  284. function logging_on_pleroma {
  285. echo -n ''
  286. }
  287. function logging_off_pleroma {
  288. echo -n ''
  289. }
  290. function remove_user_pleroma {
  291. remove_username="$1"
  292. cd $PLEROMA_DIR || exit 252498
  293. mix rm_user "$remove_username"
  294. "${PROJECT_NAME}-pass" -u "$remove_username" --rmapp pleroma
  295. }
  296. function add_user_pleroma {
  297. new_username="$1"
  298. new_user_password="$2"
  299. cd $PLEROMA_DIR || exit 348346
  300. mix register_user "$new_username" "$new_username" "$new_username@$HOSTNAME" $"Your bio goes here" "$new_user_password"
  301. "${PROJECT_NAME}-pass" -u "$new_username" -a pleroma -p "$new_user_password"
  302. echo '0'
  303. }
  304. function install_interactive_pleroma {
  305. if [ ! "$ONION_ONLY" ]; then
  306. ONION_ONLY='no'
  307. fi
  308. if [[ $ONION_ONLY != "no" ]]; then
  309. PLEROMA_DOMAIN_NAME='pleroma.local'
  310. else
  311. PLEROMA_DETAILS_COMPLETE=
  312. while [ ! $PLEROMA_DETAILS_COMPLETE ]
  313. do
  314. data=$(mktemp 2>/dev/null)
  315. if [[ "$DDNS_PROVIDER" == *"freedns"* ]]; then
  316. dialog --backtitle $"Freedombone Configuration" \
  317. --title $"Pleroma Configuration" \
  318. --form $"\\nPlease enter your Pleroma details. The background image URL can be left blank.\\n\\nIMPORTANT: This should be a domain name which is supported by Let's Encrypt:" 16 65 4 \
  319. $"Domain:" 1 1 "$(grep 'PLEROMA_DOMAIN_NAME' temp.cfg | awk -F '=' '{print $2}')" 1 25 33 40 \
  320. $"Title:" 2 1 "$(grep "$PLEROMA_TITLE" temp.cfg | awk -F '=' '{print $2}')" 2 25 255 255 \
  321. $"Background image URL:" 3 1 "$(grep "$PLEROMA_BACKGROUND_IMAGE_URL" temp.cfg | awk -F '=' '{print $2}')" 3 25 255 255 \
  322. $"Code:" 4 1 "$(grep 'PLEROMA_CODE' temp.cfg | awk -F '=' '{print $2}')" 4 25 33 255 \
  323. 2> "$data"
  324. else
  325. dialog --backtitle $"Freedombone Configuration" \
  326. --title $"Pleroma Configuration" \
  327. --form $"\\nPlease enter your Pleroma details. The background image URL can be left blank.\\n\\nIMPORTANT: This should be a domain name which is supported by Let's Encrypt:" 16 65 4 \
  328. $"Domain:" 1 1 "$(grep 'PLEROMA_DOMAIN_NAME' temp.cfg | awk -F '=' '{print $2}')" 1 25 33 40 \
  329. $"Title:" 2 1 "$(grep "$PLEROMA_TITLE" temp.cfg | awk -F '=' '{print $2}')" 2 25 255 255 \
  330. $"Background image URL:" 3 1 "$(grep "$PLEROMA_BACKGROUND_IMAGE_URL" temp.cfg | awk -F '=' '{print $2}')" 3 25 255 255 \
  331. 2> "$data"
  332. fi
  333. sel=$?
  334. case $sel in
  335. 1) rm -f "$data"
  336. exit 1;;
  337. 255) rm -f "$data"
  338. exit 1;;
  339. esac
  340. PLEROMA_DOMAIN_NAME=$(sed -n 1p < "$data")
  341. title=$(sed -n 2p < "$data")
  342. if [ ${#title} -gt 1 ]; then
  343. PLEROMA_TITLE="$title"
  344. fi
  345. img_url=$(sed -n 3p < "$data")
  346. if [ ${#img_url} -gt 1 ]; then
  347. PLEROMA_BACKGROUND_IMAGE_URL=$img_url
  348. fi
  349. if [ "$PLEROMA_DOMAIN_NAME" ]; then
  350. if [[ $PLEROMA_DOMAIN_NAME == "$HUBZILLA_DOMAIN_NAME" ]]; then
  351. PLEROMA_DOMAIN_NAME=""
  352. fi
  353. TEST_DOMAIN_NAME=$PLEROMA_DOMAIN_NAME
  354. validate_domain_name
  355. if [[ "$TEST_DOMAIN_NAME" != "$PLEROMA_DOMAIN_NAME" ]]; then
  356. PLEROMA_DOMAIN_NAME=
  357. dialog --title $"Domain name validation" --msgbox "$TEST_DOMAIN_NAME" 15 50
  358. else
  359. if [[ "$DDNS_PROVIDER" == *"freedns"* ]]; then
  360. PLEROMA_CODE=$(sed -n 4p < "$data")
  361. validate_freedns_code "$PLEROMA_CODE"
  362. if [ ! "$VALID_CODE" ]; then
  363. PLEROMA_DOMAIN_NAME=
  364. fi
  365. fi
  366. fi
  367. fi
  368. if [ $PLEROMA_DOMAIN_NAME ]; then
  369. PLEROMA_DETAILS_COMPLETE="yes"
  370. fi
  371. rm -f "$data"
  372. done
  373. # remove any invalid characters
  374. if [ ${#PLEROMA_TITLE} -gt 0 ]; then
  375. new_title=${PLEROMA_TITLE//\'/}
  376. PLEROMA_TITLE="$new_title"
  377. fi
  378. # save the results in the config file
  379. write_config_param "PLEROMA_CODE" "$PLEROMA_CODE"
  380. write_config_param "PLEROMA_TITLE" "$PLEROMA_TITLE"
  381. write_config_param "PLEROMA_BACKGROUND_IMAGE_URL" "$PLEROMA_BACKGROUND_IMAGE_URL"
  382. fi
  383. write_config_param "PLEROMA_DOMAIN_NAME" "$PLEROMA_DOMAIN_NAME"
  384. APP_INSTALLED=1
  385. }
  386. function change_password_pleroma {
  387. # curr_username="$1"
  388. new_user_password="$2"
  389. #${PROJECT_NAME}-pass -u "$curr_username" -a pleroma -p "$new_user_password"
  390. }
  391. function pleroma_create_database_failed {
  392. run_system_query_postgresql "ALTER USER pleroma NOSUPERUSER;"
  393. run_system_query_postgresql "ALTER USER pleroma NOCREATEDB;"
  394. }
  395. function pleroma_create_database {
  396. if [ -f "$IMAGE_PASSWORD_FILE" ]; then
  397. PLEROMA_ADMIN_PASSWORD="$(printf "%s" "$(cat "$IMAGE_PASSWORD_FILE")")"
  398. else
  399. if [ ! "$PLEROMA_ADMIN_PASSWORD" ]; then
  400. PLEROMA_ADMIN_PASSWORD="$(create_password "${MINIMUM_PASSWORD_LENGTH}")"
  401. fi
  402. fi
  403. if [ ! "$PLEROMA_ADMIN_PASSWORD" ]; then
  404. return
  405. fi
  406. systemctl restart postgresql
  407. add_postgresql_user pleroma "$PLEROMA_ADMIN_PASSWORD" encrypted
  408. run_system_query_postgresql "create database pleroma;"
  409. # temporarily allow the user to create databases
  410. run_system_query_postgresql "ALTER USER pleroma CREATEDB;"
  411. run_system_query_postgresql "ALTER USER pleroma SUPERUSER;"
  412. run_system_query_postgresql "GRANT ALL ON ALL tables IN SCHEMA public TO pleroma;"
  413. run_system_query_postgresql "GRANT ALL ON ALL sequences IN SCHEMA public TO pleroma;"
  414. run_system_query_postgresql "CREATE EXTENSION citext;"
  415. run_system_query_postgresql "set statement_timeout to 40000;"
  416. read_config_param "PLEROMA_SECRET_KEY"
  417. if [ ${#PLEROMA_SECRET_KEY} -lt 64 ]; then
  418. PLEROMA_SECRET_KEY="$(create_password 30)$(create_password 30)$(create_password 30)"
  419. if [ ${#PLEROMA_SECRET_KEY} -lt 64 ]; then
  420. pleroma_create_database_failed
  421. echo $'Pleroma secret key not created'
  422. exit 6782352
  423. fi
  424. write_config_param "PLEROMA_SECRET_KEY" "$PLEROMA_SECRET_KEY"
  425. fi
  426. if [ ! -d $PLEROMA_DIR/config ]; then
  427. echo $"Missing directory $PLEROMA_DIR/config"
  428. exit 7835393
  429. fi
  430. if [ ! -f $PLEROMA_DIR/config/dev.exs ]; then
  431. echo $"Did not find $PLEROMA_DIR/config/dev.exs"
  432. exit 78923528
  433. fi
  434. cp $PLEROMA_DIR/config/dev.exs $pleroma_secret
  435. sed -i "s|username:.*|username: \"pleroma\",|g" $pleroma_secret
  436. sed -i "s|password:.*|password: \"$PLEROMA_ADMIN_PASSWORD\",|g" $pleroma_secret
  437. sed -i "s|database:.*|database: \"pleroma\",|g" $pleroma_secret
  438. sed -i "/Pleroma.Web.Endpoint/a secret_key_base: \"$PLEROMA_SECRET_KEY\"," $pleroma_secret
  439. sed -i 's|secret_key_base: | secret_key_base: |g' $pleroma_secret
  440. sed -i "/Pleroma.Web.Endpoint/a pubsub: [name: Pleroma.Web.PubSub, adapter: Phoenix.PubSub.PG2]," $pleroma_secret
  441. sed -i 's|pubsub: | pubsub: |g' $pleroma_secret
  442. sed -i 's|watchers: []|watchers: [],|g' $pleroma_secret
  443. if [[ $ONION_ONLY == 'no' ]]; then
  444. sed -i "/watchers: []/a url: [host: \"$PLEROMA_DOMAIN_NAME\", scheme: \"https\", port: 443]" $pleroma_secret
  445. else
  446. sed -i "/watchers: []/a url: [host: \"$PLEROMA_ONION_HOSTNAME\", scheme: \"http\", port: 80]" $pleroma_secret
  447. fi
  448. sed -i 's|url: | url: |g' $pleroma_secret
  449. if ! grep -q "pbkdf2_rounds" $pleroma_secret; then
  450. sed -i '/config :logger/a config :comeonin, :pbkdf2_rounds, 1' $pleroma_secret
  451. else
  452. sed -i 's|pbkdf2_rounds.*|pbkdf2_rounds, 1|g' $pleroma_secret
  453. fi
  454. sed -i 's|import_config|# import_config|g' $pleroma_secret
  455. cd "$PLEROMA_DIR" || exit 678245245724
  456. chown -R pleroma:pleroma $PLEROMA_DIR/*
  457. if ! sudo -u pleroma mix local.rebar --force; then
  458. pleroma_create_database_failed
  459. echo $'mix local.rebar failed'
  460. exit 73528562
  461. fi
  462. sudo -u pleroma mix local.hex --force
  463. sudo -u pleroma mix deps.compile mimerl
  464. systemctl restart postgresql
  465. if ! sudo -u pleroma mix ecto.create --force; then
  466. pleroma_create_database_failed
  467. echo $'mix ecto.create failed'
  468. exit 83653582
  469. fi
  470. if ! sudo -u pleroma mix ecto.migrate --force; then
  471. pleroma_create_database_failed
  472. echo $'mix ecto.migrate failed'
  473. exit 73752573
  474. fi
  475. # revoke the ability to create databases for this user
  476. run_system_query_postgresql "ALTER USER pleroma NOSUPERUSER;"
  477. run_system_query_postgresql "ALTER USER pleroma NOCREATEDB;"
  478. }
  479. function reconfigure_pleroma {
  480. echo -n ''
  481. }
  482. function pleroma_set_background_image {
  483. PLEROMA_DOMAIN_NAME=$(get_completion_param "pleroma domain")
  484. data=$(mktemp 2>/dev/null)
  485. dialog --title $"Pleroma" \
  486. --backtitle $"Freedombone Control Panel" \
  487. --inputbox $'Set a background image URL' 10 60 2>"$data"
  488. sel=$?
  489. case $sel in
  490. 0)
  491. temp_background=$(<"$data")
  492. if [ ${#temp_background} -gt 0 ]; then
  493. PLEROMA_BACKGROUND_IMAGE_URL="$temp_background"
  494. write_config_param "PLEROMA_BACKGROUND_IMAGE_URL" "$PLEROMA_BACKGROUND_IMAGE_URL"
  495. if [[ $(pleroma_set_background_image_from_url $PLEROMA_DIR "$PLEROMA_DOMAIN_NAME" "$PLEROMA_BACKGROUND_IMAGE_URL" "$PLEROMA_TITLE" | tail -n 1) == "0" ]]; then
  496. pleroma_recompile
  497. dialog --title $"Set Pleroma login background" \
  498. --msgbox $"The background image has been set" 6 60
  499. fi
  500. fi
  501. ;;
  502. esac
  503. rm -f "$data"
  504. }
  505. function pleroma_set_title {
  506. data=$(mktemp 2>/dev/null)
  507. dialog --title $"Pleroma" \
  508. --backtitle $"Freedombone Control Panel" \
  509. --inputbox $'Set a title' 10 60 2>"$data"
  510. sel=$?
  511. case $sel in
  512. 0)
  513. new_title=$(<"$data")
  514. if [ ${#new_title} -gt 0 ]; then
  515. PLEROMA_TITLE="$new_title"
  516. PLEROMA_DOMAIN_NAME=$(get_completion_param "pleroma domain")
  517. write_config_param "PLEROMA_TITLE" "$PLEROMA_TITLE"
  518. sed -i "s|\"name\":.*|\"name\": \"${PLEROMA_TITLE}\",|g" $PLEROMA_DIR/static/config.json
  519. sed -i "s|\"name\":.*|\"name\": \"${PLEROMA_TITLE}\",|g" $PLEROMA_DIR/priv/static/static/config.json
  520. sed -i "s|name: .*|name: \"${PLEROMA_TITLE}\",|g" $PLEROMA_DIR/config/config.exs
  521. systemctl restart pleroma
  522. dialog --title $"Set Pleroma title" \
  523. --msgbox $"The title has been set" 6 60
  524. fi
  525. ;;
  526. esac
  527. rm -f "$data"
  528. }
  529. function pleroma_set_expire_months {
  530. PLEROMA_DOMAIN_NAME=$(get_completion_param "pleroma domain")
  531. read_config_param "PLEROMA_DOMAIN_NAME"
  532. read_config_param "PLEROMA_EXPIRE_MONTHS"
  533. data=$(mktemp 2>/dev/null)
  534. dialog --title $"Pleroma" \
  535. --backtitle $"Freedombone Control Panel" \
  536. --inputbox $'Set an expiry period for posts in months. Anything older will be deleted. Lower values help to keep the database size small and as fast as possible.' 12 60 "$PLEROMA_EXPIRE_MONTHS" 2>"$data"
  537. sel=$?
  538. case $sel in
  539. 0)
  540. new_expiry_months=$(<"$data")
  541. if [ ${#new_expiry_months} -gt 0 ]; then
  542. # should contain no spaces
  543. if [[ "$new_expiry_months" == *" "* ]]; then
  544. rm -f "$data"
  545. return
  546. fi
  547. # should be a number
  548. re='^[0-9]+$'
  549. if ! [[ $new_expiry_months =~ $re ]] ; then
  550. rm -f "$data"
  551. return
  552. fi
  553. # set the new value
  554. PLEROMA_EXPIRE_MONTHS=$new_expiry_months
  555. write_config_param "PLEROMA_EXPIRE_MONTHS" "$PLEROMA_EXPIRE_MONTHS"
  556. expire_pleroma_posts "$PLEROMA_DOMAIN_NAME" "$PLEROMA_EXPIRE_MONTHS"
  557. create_pleroma_blocklist
  558. dialog --title $"Set Pleroma post expiry period" \
  559. --msgbox $"Expiry period set to $PLEROMA_EXPIRE_MONTHS months" 6 60
  560. fi
  561. ;;
  562. esac
  563. rm -f "$data"
  564. }
  565. function pleroma_disable_registrations {
  566. dialog --title $"Disable new Pleroma user registrations" \
  567. --backtitle $"Freedombone Control Panel" \
  568. --yesno $"\\nDo you wish to disable new registrations?" 10 60
  569. sel=$?
  570. case $sel in
  571. 0) sed -i 's|registrations_open: true|registrations_open: false|g' $PLEROMA_DIR/config/config.exs
  572. sed -i 's|registrations_open: True|registrations_open: false|g' $PLEROMA_DIR/config/config.exs
  573. sed -i 's|"registrationOpen": true|"registrationOpen": false|g' $PLEROMA_DIR/priv/static/static/config.json
  574. sed -i 's|"registrationOpen": True|"registrationOpen": false|g' $PLEROMA_DIR/priv/static/static/config.json
  575. ;;
  576. 1) sed -i 's|registrations_open: false|registrations_open: true|g' $PLEROMA_DIR/config/config.exs
  577. sed -i 's|registrations_open: False|registrations_open: true|g' $PLEROMA_DIR/config/config.exs
  578. sed -i 's|"registrationOpen": false|"registrationOpen": true|g' $PLEROMA_DIR/priv/static/static/config.json
  579. sed -i 's|"registrationOpen": False|"registrationOpen": true|g' $PLEROMA_DIR/priv/static/static/config.json
  580. ;;
  581. 255) return;;
  582. esac
  583. pleroma_recompile
  584. }
  585. function pleroma_add_emoji {
  586. emoji_resolution='128x128'
  587. data=$(mktemp 2>/dev/null)
  588. dialog --backtitle $"Freedombone Control Panel" \
  589. --title $"Add Custom Emoji" \
  590. --form "\\n" 8 75 2 \
  591. $"Shortcode:" 1 1 "" 1 18 16 15 \
  592. $"ImageURL:" 2 1 "" 2 18 512 10000 \
  593. 2> "$data"
  594. sel=$?
  595. case $sel in
  596. 1) rm -f "$data"
  597. return;;
  598. 255) rm -f "$data"
  599. return;;
  600. esac
  601. shortcode=$(sed -n 1p < "$data")
  602. image_url=$(sed -n 2p < "$data")
  603. rm -f "$data"
  604. if [ ${#shortcode} -lt 2 ]; then
  605. return
  606. fi
  607. if [ ${#image_url} -lt 2 ]; then
  608. return
  609. fi
  610. if [[ "$image_url" != *'.'* ]]; then
  611. return
  612. fi
  613. if [[ "$image_url" != *'.png' && "$image_url" != *'.jpg' && "$image_url" != *'.jpeg' && "$image_url" != *'.gif' ]]; then
  614. dialog --title $"Add Custom Emoji" \
  615. --msgbox $"The image must be png/jpg/gif format" 6 60
  616. return
  617. fi
  618. if [[ "$shortcode" == *':'* || "$shortcode" == *' '* || "$shortcode" == *'.'* || "$shortcode" == *'!'* ]]; then
  619. dialog --title $"Add Custom Emoji" \
  620. --msgbox $"The shortcode contains invalid characters" 6 60
  621. return
  622. fi
  623. image_extension='png'
  624. if [[ "$image_url" == *'.jpg' || "$image_url" == *'.jpeg' ]]; then
  625. image_extension='jpg'
  626. fi
  627. if [[ "$image_url" == *'.gif' ]]; then
  628. image_extension='gif'
  629. fi
  630. if [ ! -d $PLEROMA_DIR/priv/static/emoji ]; then
  631. mkdir -p $PLEROMA_DIR/priv/static/emoji
  632. fi
  633. image_filename=$PLEROMA_DIR/priv/static/emoji/${shortcode}.${image_extension}
  634. wget "$image_url" -O "$image_filename"
  635. if [ ! -f "$image_filename" ]; then
  636. dialog --title $"Add Custom Emoji" \
  637. --msgbox $"Unable to download the image" 6 60
  638. return
  639. fi
  640. if [[ "$image_url" == *'.jpg' || "$image_url" == *'.jpeg' || "$image_url" == *'.gif' ]]; then
  641. convert "$image_filename" -resize "$emoji_resolution" "$PLEROMA_DIR/priv/static/emoji/${shortcode}.png"
  642. if [ ! -f "$PLEROMA_DIR/priv/static/emoji/${shortcode}.png" ]; then
  643. dialog --title $"Add Custom Emoji" \
  644. --msgbox $"Unable to convert empji image to png format" 6 60
  645. return
  646. fi
  647. # remove the original
  648. rm "$image_filename"
  649. image_extension='png'
  650. image_filename=$PLEROMA_DIR/priv/static/emoji/${shortcode}.${image_extension}
  651. else
  652. convert "$image_filename" -resize "$emoji_resolution" "$image_filename"
  653. fi
  654. if ! grep -q "${shortcode}," $PLEROMA_DIR/config/emoji.txt; then
  655. echo "${shortcode}, /emoji/${shortcode}.${image_extension}" >> $PLEROMA_DIR/config/emoji.txt
  656. else
  657. sed -i "s|${shortcode},.*|${shortcode}, /emoji/${shortcode}.${image_extension}|g" $PLEROMA_DIR/config/emoji.txt
  658. fi
  659. chown -R pleroma:pleroma $PLEROMA_DIR
  660. clear
  661. echo ''
  662. echo $'Recompiling Pleroma with the new emoji'
  663. systemctl stop pleroma
  664. pleroma_recompile
  665. dialog --title $"Add Custom Emoji" \
  666. --msgbox $"Custom emoji :${shortcode}: has been added" 6 70
  667. }
  668. function configure_interactive_pleroma {
  669. read_config_param PLEROMA_DOMAIN_NAME
  670. read_config_param PLEROMA_EXPIRE_MONTHS
  671. while true
  672. do
  673. chatenabled=
  674. enablechatstr=$'Enable chat system'
  675. if grep -q ':chat, enabled: true' $PLEROMA_DIR/config/config.exs; then
  676. chatenabled=1
  677. enablechatstr=$'Disable chat system'
  678. fi
  679. pleromatorstr=$'Enable routing through Tor for onion addresses'
  680. if grep -q '9050' $pleroma_secret; then
  681. pleromatorstr=$'Disable routing through Tor'
  682. fi
  683. W=(1 $"Set a background image"
  684. 2 $"Set the title"
  685. 3 $"Disable new account registrations"
  686. 4 $"Add a custom emoji"
  687. 5 $"Set post expiry period (currently $PLEROMA_EXPIRE_MONTHS months)"
  688. 6 "$enablechatstr"
  689. 7 "$pleromatorstr")
  690. # shellcheck disable=SC2068
  691. selection=$(dialog --backtitle $"Freedombone Administrator Control Panel" --title $"Pleroma" --menu $"Choose an operation, or ESC to exit:" 14 60 7 "${W[@]}" 3>&2 2>&1 1>&3)
  692. if [ ! "$selection" ]; then
  693. break
  694. fi
  695. case $selection in
  696. 1) pleroma_set_background_image;;
  697. 2) pleroma_set_title;;
  698. 3) pleroma_disable_registrations;;
  699. 4) pleroma_add_emoji;;
  700. 5) pleroma_set_expire_months;;
  701. 6) if [ $chatenabled ]; then
  702. pleroma_enable_chat false
  703. else
  704. pleroma_enable_chat true
  705. fi
  706. ;;
  707. 7) if grep -q '9050' $pleroma_secret; then
  708. pleroma_disable_tor
  709. else
  710. pleroma_enable_tor
  711. fi
  712. ;;
  713. esac
  714. done
  715. }
  716. function pleroma_disable_tor {
  717. if grep -q '9050' $pleroma_secret; then
  718. sed -i '/9050/d' $pleroma_secret
  719. sed -i 's|# config :pleroma, :http, proxy_url:|config :pleroma, :http, proxy_url:|g' $PLEROMA_DIR/config/config.exs
  720. pleroma_recompile
  721. fi
  722. }
  723. function pleroma_enable_tor {
  724. pleroma_tor_update=
  725. if ! grep -q '{:socks5, :localhost, 9050}' $pleroma_secret; then
  726. pleroma_tor_update=1
  727. fi
  728. if ! grep -q '# config :pleroma, :http, proxy_url:' $PLEROMA_DIR/config/config.exs; then
  729. pleroma_tor_update=1
  730. fi
  731. if [ ! $pleroma_tor_update ]; then
  732. return
  733. fi
  734. if ! grep -q '{:socks5, :localhost, 9050}' $pleroma_secret; then
  735. sed -i '/9050/d' $pleroma_secret
  736. sed -i '/url:/a config :pleroma, :http, proxy_url: {:socks5, :localhost, 9050}' $pleroma_secret
  737. fi
  738. if ! grep -q '# config :pleroma, :http, proxy_url:' $PLEROMA_DIR/config/config.exs; then
  739. sed -i 's|config :pleroma, :http, proxy_url:|# config :pleroma, :http, proxy_url:|g' $PLEROMA_DIR/config/config.exs
  740. fi
  741. pleroma_recompile
  742. }
  743. function upgrade_pleroma {
  744. read_config_param PLEROMA_DOMAIN_NAME
  745. read_config_param PLEROMA_EXPIRE_MONTHS
  746. pleroma_add_filtering
  747. if ! grep -q "/media/" /etc/cron.daily/pleroma-expire; then
  748. rm $pleroma_expire_posts_script
  749. fi
  750. if [ ! -f $pleroma_expire_posts_script ]; then
  751. expire_pleroma_posts "$PLEROMA_DOMAIN_NAME" "$PLEROMA_EXPIRE_MONTHS"
  752. fi
  753. if [ ! -f $blocking_script_file ]; then
  754. create_pleroma_blocklist
  755. fi
  756. #pleroma_enable_tor
  757. CURR_PLEROMA_COMMIT=$(get_completion_param "pleroma commit")
  758. if [[ "$CURR_PLEROMA_COMMIT" == "$PLEROMA_COMMIT" ]]; then
  759. return
  760. fi
  761. pleroma_registrations=open
  762. if grep -q 'registrations_open: false' $PLEROMA_DIR/config/config.exs; then
  763. pleroma_registrations=
  764. fi
  765. pleroma_chat_enabled=1
  766. if grep -q ':chat, enabled: false' $PLEROMA_DIR/config/config.exs; then
  767. pleroma_chat_enabled=
  768. fi
  769. # make a copy of the configuration
  770. cp $PLEROMA_DIR/priv/static/static/config.json $PLEROMA_DIR/priv/static/static/config_prev.json
  771. if [ -f $PLEROMA_DIR/config/emoji.txt ]; then
  772. cp $PLEROMA_DIR/config/emoji.txt $PLEROMA_DIR/config/emoji_prev.txt
  773. fi
  774. apt-get -yq update
  775. apt-get -yq install --only-upgrade esl-erlang
  776. apt-get -yq install --only-upgrade elixir erlang-xmerl erlang-dev erlang-parsetools
  777. function_check set_repo_commit
  778. set_repo_commit $PLEROMA_DIR "pleroma commit" "$PLEROMA_COMMIT" $PLEROMA_REPO
  779. chown -R pleroma:pleroma $PLEROMA_DIR
  780. # restore the configuration
  781. cp $PLEROMA_DIR/priv/static/static/config_prev.json $PLEROMA_DIR/priv/static/static/config.json
  782. chown pleroma:pleroma $PLEROMA_DIR/priv/static/static/config.json
  783. if [ -f $PLEROMA_DIR/config/emoji_prev.txt ]; then
  784. cp $PLEROMA_DIR/config/emoji_prev.txt $PLEROMA_DIR/config/emoji.txt
  785. chown pleroma:pleroma $PLEROMA_DIR/config/emoji.txt
  786. rm cp $PLEROMA_DIR/config/emoji_prev.txt
  787. fi
  788. sudo -u pleroma mix deps.get
  789. if [ ! $pleroma_registrations ]; then
  790. sed -i 's|registrations_open: true|registrations_open: false|g' $PLEROMA_DIR/config/config.exs
  791. sed -i 's|registrations_open: True|registrations_open: false|g' $PLEROMA_DIR/config/config.exs
  792. fi
  793. if [ ! $pleroma_chat_enabled ]; then
  794. sed -i 's|config :pleroma, :chat.*|config :pleroma, :chat, enabled: false|g' $PLEROMA_DIR/config/config.exs
  795. else
  796. sed -i 's|config :pleroma, :chat.*|config :pleroma, :chat, enabled: true|g' $PLEROMA_DIR/config/config.exs
  797. fi
  798. pleroma_recompile
  799. # migrate database
  800. sudo -u pleroma mix deps.clean --build mime
  801. sudo -u pleroma mix ecto.migrate
  802. pleroma_custom_logo "$PLEROMA_DIR"
  803. expire_pleroma_posts "$PLEROMA_DOMAIN_NAME" "$PLEROMA_EXPIRE_MONTHS"
  804. create_pleroma_blocklist
  805. chown -R pleroma:pleroma $PLEROMA_DIR
  806. systemctl restart pleroma
  807. }
  808. function backup_local_pleroma {
  809. PLEROMA_DOMAIN_NAME='pleroma'
  810. if grep -q "pleroma domain" "$COMPLETION_FILE"; then
  811. PLEROMA_DOMAIN_NAME=$(get_completion_param "pleroma domain")
  812. fi
  813. systemctl stop pleroma
  814. function_check suspend_site
  815. suspend_site "${PLEROMA_DOMAIN_NAME}"
  816. source_directory=$PLEROMA_DIR
  817. dest_directory=pleroma
  818. backup_directory_to_usb $source_directory $dest_directory
  819. USE_POSTGRESQL=1
  820. function_check backup_database_to_usb
  821. backup_database_to_usb pleroma
  822. function_check restart_site
  823. restart_site
  824. systemctl restart pleroma
  825. }
  826. function restore_local_pleroma {
  827. if ! grep -q "pleroma domain" "$COMPLETION_FILE"; then
  828. return
  829. fi
  830. PLEROMA_DOMAIN_NAME=$(get_completion_param "pleroma domain")
  831. if [ "$PLEROMA_DOMAIN_NAME" ]; then
  832. echo $"Restoring pleroma"
  833. temp_restore_dir=/root/temppleroma
  834. pleroma_dir=$PLEROMA_DIR
  835. systemctl stop pleroma
  836. PLEROMA_ONION_HOSTNAME=$(cat /var/lib/tor/hidden_service_pleroma/hostname)
  837. function_check pleroma_create_database
  838. pleroma_create_database
  839. USE_POSTGRESQL=1
  840. restore_database pleroma
  841. if [ -d $temp_restore_dir ]; then
  842. rm -rf $temp_restore_dir
  843. fi
  844. function_check restore_directory_from_usb
  845. restore_directory_from_usb $temp_restore_dir pleroma
  846. if [ -d $temp_restore_dir ]; then
  847. chown -R pleroma:pleroma $pleroma_dir
  848. rm -rf $temp_restore_dir
  849. fi
  850. systemctl restart pleroma
  851. echo $"Restore of pleroma complete"
  852. fi
  853. }
  854. function backup_remote_pleroma {
  855. PLEROMA_DOMAIN_NAME='pleroma'
  856. if grep -q "pleroma domain" "$COMPLETION_FILE"; then
  857. PLEROMA_DOMAIN_NAME=$(get_completion_param "pleroma domain")
  858. fi
  859. systemctl stop pleroma
  860. function_check suspend_site
  861. suspend_site "${PLEROMA_DOMAIN_NAME}"
  862. source_directory=$PLEROMA_DIR
  863. dest_directory=pleroma
  864. backup_directory_to_friend $source_directory $dest_directory
  865. USE_POSTGRESQL=1
  866. function_check backup_database_to_friend
  867. backup_database_to_friend pleroma
  868. function_check restart_site
  869. restart_site
  870. systemctl restart pleroma
  871. }
  872. function restore_remote_pleroma {
  873. if ! grep -q "pleroma domain" "$COMPLETION_FILE"; then
  874. return
  875. fi
  876. PLEROMA_DOMAIN_NAME=$(get_completion_param "pleroma domain")
  877. if [ "$PLEROMA_DOMAIN_NAME" ]; then
  878. echo $"Restoring pleroma"
  879. temp_restore_dir=/root/temppleroma
  880. pleroma_dir=$PLEROMA_DIR
  881. systemctl stop pleroma
  882. PLEROMA_ONION_HOSTNAME=$(cat /var/lib/tor/hidden_service_pleroma/hostname)
  883. function_check pleroma_create_database
  884. pleroma_create_database
  885. # shellcheck disable=SC2034
  886. USE_POSTGRESQL=1
  887. function_check restore_database_from_friend
  888. restore_database_from_friend pleroma
  889. if [ -d $temp_restore_dir ]; then
  890. rm -rf $temp_restore_dir
  891. fi
  892. function_check restore_directory_from_friend
  893. restore_directory_from_friend $temp_restore_dir pleroma
  894. if [ -d $temp_restore_dir ]; then
  895. chown -R pleroma:pleroma $pleroma_dir
  896. rm -rf $temp_restore_dir
  897. fi
  898. systemctl restart pleroma
  899. echo $"Restore of pleroma complete"
  900. fi
  901. }
  902. function remove_pleroma {
  903. if [ ${#PLEROMA_DOMAIN_NAME} -eq 0 ]; then
  904. return
  905. fi
  906. systemctl stop pleroma
  907. systemctl disable pleroma
  908. rm /etc/systemd/system/pleroma.service
  909. userdel pleroma
  910. #remove_elixir
  911. function_check remove_nodejs
  912. remove_nodejs pleroma-backend
  913. read_config_param "PLEROMA_DOMAIN_NAME"
  914. read_config_param "MY_USERNAME"
  915. echo "Removing $PLEROMA_DOMAIN_NAME"
  916. nginx_dissite "$PLEROMA_DOMAIN_NAME"
  917. remove_certs "$PLEROMA_DOMAIN_NAME"
  918. if [ -d "/var/www/$PLEROMA_DOMAIN_NAME" ]; then
  919. rm -rf "/var/www/$PLEROMA_DOMAIN_NAME"
  920. fi
  921. if [ -f "/etc/nginx/sites-available/$PLEROMA_DOMAIN_NAME" ]; then
  922. rm "/etc/nginx/sites-available/$PLEROMA_DOMAIN_NAME"
  923. fi
  924. if [ -d $PLEROMA_DIR ]; then
  925. rm -rf $PLEROMA_DIR
  926. fi
  927. function_check drop_database_postgresql
  928. drop_database_postgresql pleroma
  929. function_check remove_onion_service
  930. remove_onion_service pleroma ${PLEROMA_ONION_PORT}
  931. remove_app pleroma
  932. remove_completion_param install_pleroma
  933. sed -i '/pleroma domain/d' "$COMPLETION_FILE"
  934. sed -i '/pleroma commit/d' "$COMPLETION_FILE"
  935. sed -i "/$blocking_script_file/d" /etc/crontab
  936. if [ -f /usr/bin/pleroma-blocking ]; then
  937. rm /usr/bin/pleroma-blocking
  938. fi
  939. function_check remove_ddns_domain
  940. remove_ddns_domain "$PLEROMA_DOMAIN_NAME"
  941. }
  942. function image_install_pleroma {
  943. if [[ "$SOCIALINSTANCE" != 'pleroma' ]]; then
  944. return
  945. fi
  946. # shellcheck disable=SC2154
  947. chroot "$rootdir" apt-get -yq install wget imagemagick
  948. image_install_elixir
  949. image_install_postgresql
  950. }
  951. function install_pleroma {
  952. if [ ! $ONION_ONLY ]; then
  953. ONION_ONLY='no'
  954. fi
  955. apt-get -yq install wget imagemagick
  956. # We need elixir 1.4+ here, so the debian repo package won't do
  957. install_elixir
  958. function_check install_nodejs
  959. install_nodejs pleroma-backend
  960. install_postgresql
  961. if [ ! -d "/var/www/${PLEROMA_DOMAIN_NAME}/htdocs" ]; then
  962. mkdir -p "/var/www/${PLEROMA_DOMAIN_NAME}/htdocs"
  963. fi
  964. if [ -d $PLEROMA_DIR ]; then
  965. rm -rf $PLEROMA_DIR
  966. fi
  967. # get the repo
  968. if [ -f /repos/pleroma/index.html ]; then
  969. mv /repos/pleroma /repos/pleroma-fe
  970. fi
  971. if [ -d /repos/pleroma ]; then
  972. mkdir -p $PLEROMA_DIR
  973. cp -r -p /repos/pleroma/. $PLEROMA_DIR
  974. cd "$PLEROMA_DIR" || exit 834537453
  975. git pull
  976. else
  977. function_check git_clone
  978. git_clone $PLEROMA_REPO $PLEROMA_DIR
  979. fi
  980. if [ ! -d $PLEROMA_DIR ]; then
  981. echo $'Unable to clone pleroma backend repo'
  982. exit 783523
  983. fi
  984. # create user
  985. useradd -d $PLEROMA_DIR -s /bin/false pleroma
  986. # checkout the commit
  987. cd "$PLEROMA_DIR" || exit 62452428
  988. git checkout $PLEROMA_COMMIT -b $PLEROMA_COMMIT
  989. set_completion_param "pleroma commit" "$PLEROMA_COMMIT"
  990. chown -R pleroma:pleroma $PLEROMA_DIR
  991. # web config
  992. function_check add_ddns_domain
  993. add_ddns_domain "$PLEROMA_DOMAIN_NAME"
  994. PLEROMA_ONION_HOSTNAME=$(add_onion_service pleroma 80 ${PLEROMA_ONION_PORT})
  995. pleroma_nginx_site=/etc/nginx/sites-available/$PLEROMA_DOMAIN_NAME
  996. if [[ $ONION_ONLY == "no" ]]; then
  997. function_check nginx_http_redirect
  998. nginx_http_redirect "$PLEROMA_DOMAIN_NAME" "index index.html"
  999. { echo '';
  1000. echo 'proxy_cache_path /tmp/pleroma-media-cache levels=1:2 keys_zone=pleroma_media_cache:10m max_size=100m inactive=80m use_temp_path=off;';
  1001. echo '';
  1002. echo 'server {';
  1003. echo ' listen 443 ssl http2;';
  1004. echo ' #listen [::]:443 ssl http2;';
  1005. echo " server_name $PLEROMA_DOMAIN_NAME;";
  1006. echo '';
  1007. echo ' # Security'; } >> "$pleroma_nginx_site"
  1008. function_check nginx_ssl
  1009. nginx_ssl "$PLEROMA_DOMAIN_NAME"
  1010. function_check nginx_security_options
  1011. nginx_security_options "$PLEROMA_DOMAIN_NAME"
  1012. { echo ' add_header Strict-Transport-Security max-age=0;';
  1013. echo '';
  1014. echo ' # Logs';
  1015. echo ' access_log /dev/null;';
  1016. echo ' error_log /dev/null;';
  1017. echo '';
  1018. echo " root $PLEROMA_DIR;";
  1019. echo '';
  1020. echo ' index index.html;';
  1021. echo '';
  1022. echo ' gzip_vary on;';
  1023. echo ' gzip_proxied any;';
  1024. echo ' gzip_comp_level 6;';
  1025. echo ' gzip_buffers 16 8k;';
  1026. echo ' gzip_http_version 1.1;';
  1027. echo ' gzip_types text/plain text/css application/json application/javascript text/xml application/xml application/xml+rss text/javascript application/activity+json application/atom+xml;';
  1028. echo '';
  1029. echo ' location / {';
  1030. echo ' client_max_body_size 15m;';
  1031. echo ' client_body_buffer_size 15m;';
  1032. echo '';
  1033. echo ' limit_conn conn_limit_per_ip 50;';
  1034. echo ' limit_req zone=req_limit_per_ip burst=50 nodelay;';
  1035. echo '';
  1036. echo " add_header 'Access-Control-Allow-Origin' '*' always;";
  1037. echo " add_header 'Access-Control-Allow-Methods' 'POST, GET, OPTIONS' always;";
  1038. echo " add_header 'Access-Control-Allow-Headers' 'Authorization, Content-Type' always;";
  1039. echo " if (\$request_method = OPTIONS) {";
  1040. echo ' return 204;';
  1041. echo ' }';
  1042. echo '';
  1043. echo ' proxy_http_version 1.1;';
  1044. echo " proxy_set_header Upgrade \$http_upgrade;";
  1045. echo ' proxy_set_header Connection "upgrade";';
  1046. echo " proxy_set_header Host \$http_host;";
  1047. echo '';
  1048. echo " proxy_pass http://localhost:$PLEROMA_PORT;";
  1049. echo ' }';
  1050. echo '';
  1051. echo ' location /proxy {';
  1052. echo ' client_max_body_size 15m;';
  1053. echo ' client_body_buffer_size 15m;';
  1054. echo '';
  1055. echo ' limit_conn conn_limit_per_ip 50;';
  1056. echo ' limit_req zone=req_limit_per_ip burst=50 nodelay;';
  1057. echo '';
  1058. echo ' proxy_cache pleroma_media_cache;';
  1059. echo ' proxy_cache_lock on;';
  1060. echo ' proxy_ignore_client_abort on;';
  1061. echo " proxy_pass http://localhost:$PLEROMA_PORT;";
  1062. echo ' }';
  1063. echo ' # include snippets/well-known.conf;';
  1064. echo '}'; } >> "$pleroma_nginx_site"
  1065. else
  1066. echo 'proxy_cache_path /tmp/pleroma-media-cache levels=1:2 keys_zone=pleroma_media_cache:10m max_size=100m inactive=80m use_temp_path=off;' > "$pleroma_nginx_site"
  1067. echo '' >> "$pleroma_nginx_site"
  1068. fi
  1069. { echo 'server {';
  1070. echo " listen 127.0.0.1:$PLEROMA_ONION_PORT default_server;";
  1071. echo " server_name $PLEROMA_ONION_HOSTNAME;";
  1072. echo ''; } >> "$pleroma_nginx_site"
  1073. function_check nginx_security_options
  1074. nginx_security_options "$PLEROMA_DOMAIN_NAME"
  1075. { echo '';
  1076. echo ' # Logs';
  1077. echo ' access_log /dev/null;';
  1078. echo ' error_log /dev/null;';
  1079. echo '';
  1080. echo " root $PLEROMA_DIR;";
  1081. echo '';
  1082. echo ' index index.html;';
  1083. echo '';
  1084. echo ' gzip_vary on;';
  1085. echo ' gzip_proxied any;';
  1086. echo ' gzip_comp_level 6;';
  1087. echo ' gzip_buffers 16 8k;';
  1088. echo ' gzip_http_version 1.1;';
  1089. echo ' gzip_types text/plain text/css application/json application/javascript text/xml application/xml application/xml+rss text/javascript application/activity+json application/atom+xml;';
  1090. echo '';
  1091. echo ' location / {';
  1092. echo ' client_max_body_size 15m;';
  1093. echo ' client_body_buffer_size 15m;';
  1094. echo '';
  1095. echo ' limit_conn conn_limit_per_ip 50;';
  1096. echo ' limit_req zone=req_limit_per_ip burst=50 nodelay;';
  1097. echo '';
  1098. echo " add_header 'Access-Control-Allow-Origin' '*' always;";
  1099. echo " add_header 'Access-Control-Allow-Methods' 'POST, GET, OPTIONS' always;";
  1100. echo " add_header 'Access-Control-Allow-Headers' 'Authorization, Content-Type' always;";
  1101. echo " if (\$request_method = OPTIONS) {";
  1102. echo ' return 204;';
  1103. echo ' }';
  1104. echo '';
  1105. echo ' proxy_http_version 1.1;';
  1106. echo " proxy_set_header Upgrade \$http_upgrade;";
  1107. echo ' proxy_set_header Connection "upgrade";';
  1108. echo " proxy_set_header Host \$http_host;";
  1109. echo '';
  1110. echo " proxy_pass http://localhost:$PLEROMA_PORT;";
  1111. echo ' }';
  1112. echo '';
  1113. echo ' location /proxy {';
  1114. echo ' client_max_body_size 15m;';
  1115. echo ' client_body_buffer_size 15m;';
  1116. echo '';
  1117. echo ' limit_conn conn_limit_per_ip 50;';
  1118. echo ' limit_req zone=req_limit_per_ip burst=50 nodelay;';
  1119. echo '';
  1120. echo ' proxy_cache pleroma_media_cache;';
  1121. echo ' proxy_cache_lock on;';
  1122. echo ' proxy_ignore_client_abort on;';
  1123. echo " proxy_pass http://localhost:$PLEROMA_PORT;";
  1124. echo ' }';
  1125. echo ' # include snippets/well-known.conf;';
  1126. echo '}'; } >> "$pleroma_nginx_site"
  1127. # back end
  1128. cd "$PLEROMA_DIR" || exit 246824684
  1129. chown -R pleroma:pleroma "$PLEROMA_DIR/"*
  1130. if ! sudo -u pleroma mix local.hex --force; then
  1131. echo $'mix local.hex failed'
  1132. exit 1745673
  1133. fi
  1134. mix local.hex --force
  1135. if ! sudo -u pleroma mix deps.get --force; then
  1136. echo $'mix deps.get failed'
  1137. exit 7325733
  1138. fi
  1139. function_check pleroma_create_database
  1140. pleroma_create_database
  1141. "${PROJECT_NAME}-pass" -u "$MY_USERNAME" -a pleroma -p "$PLEROMA_ADMIN_PASSWORD"
  1142. # NOTE: we don't need to install the frontend separately,
  1143. # since the backend contains a precompiled version of it
  1144. install_gnusocial_default_background "pleroma" "$PLEROMA_DOMAIN_NAME"
  1145. if [ ! -f "$PLEROMA_DIR/priv/static/static/config.json" ]; then
  1146. echo $"$PLEROMA_DIR/priv/static/static/config.json file missing"
  1147. exit 323689
  1148. fi
  1149. sed -i 's|"theme":.*|"theme": "base16-summerfruit-dark.css",|g' "$PLEROMA_DIR/priv/static/static/config.json"
  1150. if [ "$PLEROMA_BACKGROUND_IMAGE_URL" ]; then
  1151. pleroma_set_background_image_from_url $PLEROMA_DIR/priv/static "$PLEROMA_DOMAIN_NAME" "$PLEROMA_BACKGROUND_IMAGE_URL" "$PLEROMA_TITLE"
  1152. fi
  1153. # Get certificate
  1154. function_check create_site_certificate
  1155. create_site_certificate "$PLEROMA_DOMAIN_NAME" 'yes'
  1156. function_check nginx_ensite
  1157. nginx_ensite "$PLEROMA_DOMAIN_NAME"
  1158. systemctl restart postgresql
  1159. systemctl restart nginx
  1160. set_completion_param "pleroma domain" "$PLEROMA_DOMAIN_NAME"
  1161. # We need to set up the url option again because it somehow gets
  1162. # lost during mix compile
  1163. if ! grep -q 'watchers: \[],' $pleroma_secret; then
  1164. sed -i 's|watchers: \[\]|watchers: \[\],|g' $pleroma_secret
  1165. fi
  1166. if ! grep -q 'url:' $pleroma_secret; then
  1167. if [[ $ONION_ONLY == 'no' ]]; then
  1168. sed -i "/watchers: /a url: [host: \"$PLEROMA_DOMAIN_NAME\", scheme: \"https\", port: 443]" $pleroma_secret
  1169. else
  1170. sed -i "/watchers: /a url: [host: \"$PLEROMA_ONION_HOSTNAME\", scheme: \"http\", port: 80]" $pleroma_secret
  1171. fi
  1172. fi
  1173. create_pleroma_blocklist
  1174. # daemon
  1175. { echo '[Unit]';
  1176. echo 'Description=Pleroma social network';
  1177. echo 'After=network.target postgresql.service';
  1178. echo '';
  1179. echo '[Service]';
  1180. echo 'User=pleroma';
  1181. echo "WorkingDirectory=$PLEROMA_DIR";
  1182. echo "Environment=\"HOME=$PLEROMA_DIR\"";
  1183. echo 'ExecStart=/usr/local/bin/mix phx.server';
  1184. echo "ExecReload=/bin/kill \$MAINPID";
  1185. echo 'KillMode=process';
  1186. echo 'Restart=on-failure';
  1187. echo '';
  1188. echo '[Install]';
  1189. echo 'WantedBy=multi-user.target';
  1190. echo 'Alias=pleroma.service'; } > /etc/systemd/system/pleroma.service
  1191. # avoid mixed content warnings
  1192. sed -i '/config :pleroma, :media_proxy/!b;n;c####enabled: true,' $PLEROMA_DIR/config/config.exs
  1193. sed -i 's|####enabled| enabled|g' $PLEROMA_DIR/config/config.exs
  1194. sed -i 's|redirect_on_failure:.*|redirect_on_failure: false|g' $PLEROMA_DIR/config/config.exs
  1195. sed -i 's|:chat, enabled:.*|:chat, enabled: false|g' $PLEROMA_DIR/config/config.exs
  1196. # onion routing
  1197. sed -i '/url:/a config :pleroma, :http, proxy_url: {:socks5, :localhost, 9050}' $pleroma_secret
  1198. sed -i 's|config :pleroma, :http, proxy_url:|# config :pleroma, :http, proxy_url:|g' $PLEROMA_DIR/config/config.exs
  1199. # set registrations open initially
  1200. sed -i 's|registrations_open:.*|registrations_open: true,|g' $PLEROMA_DIR/config/config.exs
  1201. sed -i 's|"registrationOpen":.*|"registrationOpen": true,|g' $PLEROMA_DIR/priv/static/static/config.json
  1202. if ! grep -q "media_proxy" $PLEROMA_DIR/priv/static/static/config.json; then
  1203. sed -i '/"name":/a "media_proxy": true,' $PLEROMA_DIR/priv/static/static/config.json
  1204. sed -i 's|"media_proxy"| "media_proxy"|g' $PLEROMA_DIR/priv/static/static/config.json
  1205. else
  1206. sed -i 's|"media_proxy".*|"media_proxy": false,|g' $PLEROMA_DIR/priv/static/static/config.json
  1207. fi
  1208. sed -i 's|"chatDisabled":.*|"chatDisabled": true,|g' $PLEROMA_DIR/priv/static/static/config.json
  1209. pleroma_add_filtering
  1210. systemctl daemon-reload
  1211. systemctl enable pleroma
  1212. systemctl start pleroma
  1213. cd $PLEROMA_DIR || exit 1935638
  1214. sudo -u pleroma mix register_user "$MY_USERNAME" "$MY_USERNAME" "$MY_EMAIL_ADDRESS" $"Your bio goes here" "$PLEROMA_ADMIN_PASSWORD"
  1215. sudo -u pleroma mix set_moderator "$MY_USERNAME" true
  1216. APP_INSTALLED=1
  1217. }
  1218. # NOTE: deliberately there is no "exit 0"